{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttPad.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttPad.RawType
import HROOT.Core.Deletable.Interface

class IDeletable a => ITAttPad a where
        resetAttPad :: Castable c0 CString => a -> c0 -> IO ()
        
        setBottomMargin :: a -> CDouble -> IO ()
        
        setLeftMargin :: a -> CDouble -> IO ()
        
        setRightMargin :: a -> CDouble -> IO ()
        
        setTopMargin :: a -> CDouble -> IO ()
        
        setMargin :: a -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
        
        setAfile :: a -> CDouble -> IO ()
        
        setXfile :: a -> CDouble -> IO ()
        
        setYfile :: a -> CDouble -> IO ()
        
        setAstat :: a -> CDouble -> IO ()
        
        setXstat :: a -> CDouble -> IO ()
        
        setYstat :: a -> CDouble -> IO ()

upcastTAttPad :: forall a . (FPtr a, ITAttPad a) => a -> TAttPad
upcastTAttPad h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttPad = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttPad :: forall a . (FPtr a, ITAttPad a) => TAttPad -> a
downcastTAttPad h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
