{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TDirectory.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.FFI
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TKey.RawType
import HROOT.Core.TKey.Cast
import HROOT.Core.TKey.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITDirectory TDirectory where
        append = xform2 c_tdirectory_append
        addD = xform2 c_tdirectory_addd
        appendKey = xform1 c_tdirectory_appendkey
        close = xform1 c_tdirectory_close
        get = xform1 c_tdirectory_get
        cd_TDirectory = xform1 c_tdirectory_cd_tdirectory

instance ITNamed TDirectory where
        setName = xform1 c_tdirectory_setname
        setNameTitle = xform2 c_tdirectory_setnametitle
        setTitle = xform1 c_tdirectory_settitle

instance ITObject TDirectory where
        draw = xform1 c_tdirectory_draw
        findObject = xform1 c_tdirectory_findobject
        getName = xform0 c_tdirectory_getname
        isA = xform0 c_tdirectory_isa
        paint = xform1 c_tdirectory_paint
        printObj = xform1 c_tdirectory_printobj
        saveAs = xform2 c_tdirectory_saveas
        write = xform3 c_tdirectory_write

instance IDeletable TDirectory where
        delete = xform0 c_tdirectory_delete

tDirectoryAddDirectory :: CInt -> IO ()
tDirectoryAddDirectory = xform0 c_tdirectory_tdirectoryadddirectory

tDirectoryAddDirectoryStatus :: IO CInt
tDirectoryAddDirectoryStatus
  = xformnull c_tdirectory_tdirectoryadddirectorystatus
